using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;
using TIS.Imaging.VCDHelpers;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private VCDRangeProperty _gpioIn;
        private VCDRangeProperty _gpioOut;
        private VCDButtonProperty _gpioRead;
        private VCDButtonProperty _gpioWrite;

        //<<formload
        private void Form1_Load( object sender, EventArgs e )
        {

            //xmlt@Cǂݍ
			if( !icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml") )
            {
                MessageBox.Show("No device was selected.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
                return;
            }

            // VCDvpeB̃NXāAICImagingControl IuWFNg̃vpeBɃANZX܂B
            _gpioIn = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>( VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIOIn );
            _gpioOut = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>( VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIOOut );
            _gpioRead = icImagingControl1.VCDPropertyItems.Find<VCDButtonProperty>( VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIORead );
            _gpioWrite = icImagingControl1.VCDPropertyItems.Find<VCDButtonProperty>( VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIOWrite );

            // ܂AfW^ IO ݂̃rfI Lv` foCXŃT|[gĂ邩ǂmF܂B
            if ( _gpioIn != null && _gpioOut != null && _gpioRead != null && _gpioWrite != null )
            {
                // fW^͏Ԃ擾܂B
                cmdReadDigitalInput.Enabled = true;
                ReadDigitalInput();

                // fW^o͂̏Ԃ擾܂B
                cmdWriteDigitalOutput.Enabled = true;
                chkDigitalOutputState.Enabled = true;
                if( _gpioOut.Value == 1 )
                {
                    chkDigitalOutputState.CheckState = CheckState.Checked;
                }
                else
                {
                    chkDigitalOutputState.CheckState = CheckState.Unchecked;
                }
            }
            else
            {
                cmdReadDigitalInput.Enabled = false;
                cmdWriteDigitalOutput.Enabled = false;
                chkDigitalOutputState.Enabled = false;
            }

            
            // CuXg[~OJn
            icImagingControl1.LiveStart();
        }
        //>>
        private void cmdReadDigitalInput_Click(object sender, EventArgs e)
        {
            ReadDigitalInput();
        }


        /// <summary>
        /// ReadDigitalInput
        ///
        /// rfI Lv` foCXɓǂݎp̃vbV𑗐M܂B
        /// ɁA͏ԃ`FbN{bNXfW^݂͂̌̏Ԃɐݒ肵܂B
        /// </summary>
        private void ReadDigitalInput()
        {
            // rfI Lv` foCXfW^͂ǂݎ܂B
            _gpioRead.Push();

            // fW^͂̏Ԃ chkDigitalInputState `FbN {bNXɐݒ肵܂B
            if( _gpioIn.Value == 1 )
            {
                chkDigitalInputState.CheckState = CheckState.Checked;
            }
            else
            {
                chkDigitalInputState.CheckState = CheckState.Unchecked;
            }
        }



        /// <summary>
        /// cmdWriteDigitalOutput_Click
        ///
        /// chkDigitalOutputState `FbN {bNX̏Ԃ́A
        /// rfI Lv` foCX̃fW^o̓vpeBɐݒ肳܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmdWriteDigitalOutput_Click( object sender, EventArgs e )
        {
            // `FbN{bNX̒lJɔf
            if ( chkDigitalOutputState.CheckState == CheckState.Checked )
            {
                _gpioOut.Value = 1;
            }
            else
            {
                _gpioOut.Value = 0;
            }

            // foCXɏ݂܂B
            _gpioWrite.Push();
        }
    }
}